import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class Encoder
{
    private ArrayList<String> codes;

    /**
        Constructs an encoder.
        @param filename the name of the file with the encodings.
        Each line has the format
        ch space encoding for ch
    */
    public Encoder(String filename) throws IOException
    {
        Scanner in = new Scanner(new File(filename));
        codes = new ArrayList<String>();
        while (in.hasNextLine()) codes.add(in.nextLine());
    }

    /**
        Gets the encoding for a character.
        @param ch a string containing a single character
        @return the string to which ch is encoded or null if there
        is no code.
    */
    public String encoding(String ch)
    {
        return null;
    }

    /**
        Gets the encoding for a string.
        @param str a string
        @return an array list of the encodings of all characters in str
    */
    public ArrayList<String> encode(String str)
    {
        ArrayList<String> result = new ArrayList<String>();
        return result;
    }

    /**
        Gets the encoding for a string.
        @param str a string
        @param separator the string with which to separate the encodings
        @param notCoded the string to use for any characters that are not coded
        @return a string with all encodings of the characters in str (or
        the notCoded string for those that couldn't be coded),
        each separated by the separator string.
    */
    public String encode(String str, String separator, String notCoded)
    {
        String result = "";
        return result;
    }
}
